<?php
defined('_JEXEC') or die;

class ModJlmsMenuHelper
{
	public static function getList($params)
	{
		global $Itemid;

		$pathToLms = JPATH_SITE . '/components/com_joomla_lms';
		require_once ($pathToLms . '/libraries/servicelocator.php');

		\LMS\Libraries\ServiceLocator::registerNamespace('LMS', $pathToLms);
		\LMS\Libraries\ServiceLocator::activate();

		\LMS\Libraries\ServiceLocator::load('lib.base');
		\LMS\Libraries\ServiceLocator::load('tool.coursebuilder');

		$jlmsConfig = \LMS\Libraries\ServiceLocator::get('config');

		$courseId = $jlmsConfig->get('course_id');

		$list = array();

		if($courseId){
//			var_dump($courseId);

			$currentUserType = $jlmsConfig->get('current_usertype');

			$modelLearningPattern = new \LMS\Tools\Coursebuilder\Model\LearningPattern();
			$modelLearningPattern->setState('courseId', $courseId);

			$lmsMenuItems = $modelLearningPattern->getAllowedTools($currentUserType);

//			echo '<pre>';
//			print_r($lmsMenuItems);
//			echo '</pre>';

			$item_id = $jlmsConfig->get('Itemid');

			$item_id = isset($item_id) && $item_id ? "&Itemid=".$item_id : '';

			foreach($lmsMenuItems as $item){

				$item->iconSuffix = $modelLearningPattern->getSuffixIconClass($item->lang_var);

				$task = '';
				if ($item->task){

					$task = "&task=".$item->task;
				}

				if ($item->lang_var == '_JLMS_TOOLBAR_HOME')
				{

					$task = "&view=default";
				}

				if ($item->lang_var == '_JLMS_TOOLBAR_COURSES' || $item->lang_var == '_JLMS_TOOLBAR_HOME' || $item->lang_var == '_JLMS_TOOLBAR_SUBSCRIPTIONS' || $item->lang_var == '_JLMS_TOOLBAR_LIBRARY'){
					$ids = '';
				} else {

					$ids = "&id=".$courseId;
				}

				if ($item->lang_var == '_JLMS_TOOLBAR_HELP'){

					$item->link = 'http://www.joomlalms.com/index.php?option=com_lms_help&Itemid=40&task=view_by_task&key=';
				} else {
					if ($jlmsConfig->get('under_ssl') && $jlmsConfig->get('real_live_site')) {
						$item->link = $jlmsConfig->get('real_live_site') . "/index.php?option=com_joomla_lms".$item_id.$task.$ids;
					} else {
						$item->link = JLMSRoute::_("index.php?option=com_joomla_lms".$task.$ids.$item_id);
					}
				}
				if ($item->lang_var == '_JLMS_TOOLBAR_GQP_PARENT'){
					$item->link = JLMSRoute::_("index.php?option=com_joomla_lms&amp;task=global_pool".$item_id);
				}

				$list[] = $item;
			}

//			echo '<pre>';
//			print_r($list);
//			echo '</pre>';

		}

		return $list;
	}
}