<?php
namespace LMS\Tools\Announcements\Controllers;

defined('_JEXEC') or die;

use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Announcements extends Base\Controller
{
	public function __construct($config=array())
	{
		parent::__construct($config);
        $this->input->set('view', 'announcements');
        $this->acl = ServiceLocator::get('acl');
        require_once(JPATH_ROOT.DS.'components'.DS.'com_joomla_lms'.DS.'tools'.DS.'announcements'.DS.'helpers'.DS.'announcement_output.php');
	}

    public function display($cachable=false, $urlparams=array())
    {
        $pathway = array();

        $model = $this->getModel('Announcements');
        $model->setState('course_id', $this->input->get('course_id'));
        $pathway[] = array('name' => _JLMS_TOOLBAR_AGENDA, 'link' => sefRelToAbs("index.php?option=com_joomla_lms&amp;&amp;task=attendance&amp;id=". $this->input->get('course_id')), 'is_home' => false);
        JLMSAppendPathWay($pathway);
        $view = $this->getView('Announcements');
        $view->setModel($model, true);
        $view->course_id = $this->input->get('course_id');
        $view->dateHandler = ServiceLocator::get('date_handler');
        $view->announcement_filter = $model->announcement_filter = $this->session->get('announcement_filter','all');
        $view->display();
    }

    public function set_filter()
    {
        $announcement_filter = $this->input->get('announcement_filter');
        $this->session->set('announcement_filter', $announcement_filter);
        $this->display();
    }

    public function featured()
    {
        $model = $this->getModel('Announcements');
        $this->populateModel($model);
        $view = $this->getView('Featured');
        $view->setModel($model, true);
        $view->course_id = $this->input->get('course_id');
        $view->dateHandler = ServiceLocator::get('date_handler');
        $view->display();
    }

    public function actual()
    {
        $model = $this->getModel('Announcements');
        $model->setState('course_id', $this->input->get('course_id'));
        $this->populateModel($model);
        $view = $this->getView('Actual');
        $view->setModel($model, true);
        $view->course_id = $this->input->get('course_id');
        $view->dateHandler = ServiceLocator::get('date_handler');
        $view->display();
    }

    public function change_announcement_state()
    {
        if ($this->acl->CheckPermissions('announce', 'manage') )
        {
            $announcement_id = $this->input->getInt('announcement_id');
            $state =  $this->input->getInt('state');
            $db = \JFactory::getDbo();
            $db->setQuery('UPDATE `#__lms_agenda` SET `published`='.(int)$state.' WHERE `agenda_id`='.(int)$announcement_id);
            $db->execute();
        }
        $this->display();
    }

}