<?php
namespace LMS\Tools\Homework\Repositories;

use LMS\Libraries\Base;
use LMS\Tools\Homework\Tables;

class Homework extends Base\Repository
{
	public function __construct($options = array())
	{
		parent::__construct($options);
		$this->table = new Tables\Homework($this->db);
	}

	protected function prepareFilter($query, &$filterOptions)
	{
		$alias = $this->table->getTableAlias();

		$conditions = array();

		if(isset($filterOptions['id']) && $filterOptions['id']){
			$conditions[] = $alias.".id = ".$this->db->quote($filterOptions['id']);
		}

		if(isset($filterOptions['courseId']) && $filterOptions['courseId']){
			$conditions[] = $alias.".course_id = ".$this->db->quote($filterOptions['courseId']);
		}

		if(isset($filterOptions['published'])){
			$conditions[] = $alias.".published = ".$this->db->quote($filterOptions['published']);
		}

		$query->where($conditions);

		return parent::prepareFilter($query, $filterOptions); // TODO: Change the autogenerated stub
	}
}