<?php
 
namespace LMS\Tools\Mailbox\Controllers;

defined('_JEXEC') or die;

use LMS\Libraries\User;
use LMS\Libraries\Base;
 
class Message extends Base\Controller
{
	public function show()
	{		
		$courseId = $this->config->get('course_id');
		
		$messageId = $this->input->getInt('message_id');
		
		$model	= $this->getModel('message');
		
		$model->markAsRead($messageId, $this->user->get('id'));	
		
		$this->populateModel($model);
			
		$model->setState('course_id', $courseId);
		$model->setState('message_id', $messageId);
		
		$view	= $this->getView('message', 'html');	
		$view->courseId = $courseId;
		$view->messageId = $messageId;
		$view->form	= $model->getForm('message');
		
		$view->setModel($model, true);
		$view->show();	
	}
	
	public function compose()
	{	
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		
		if ($model = $this->getModel('message'))
		{			
		
			$courseId = $this->config->get('course_id');
			$model->setState('course_id', $courseId);
			$view = $this->getView('message', 'html');
			$view->setModel($model, true);			
			$view->courseId = $courseId;
			$view->form	= $model->getForm('message');			
			$view->compose();
		}
		
		return true;
	}
	
	public function send()
	{	
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		
		$courseId = $this->config->get('course_id');
		$itemId = $this->config->get('itemId');		
				
		if ($model = $this->getModel('message')) {			
			$model->setState('userName', $this->user->name);
			$model->setState('email', $this->user->email);
			$model->setState('userId', $this->user->id);
				
			$model->sendMail(
				$this->input->get('jform', array(), 'array')				
			);		
		}		
		$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms&task=mailbox.mailbox.outbox&course_id='.$courseId));
		
		return true;
	}
	
	public function reply()
	{	
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		
		if ($model = $this->getModel('message'))
		{	
			$message = $model->getMessage($this->input->getInt('id'));		
			
			$courseId = $this->config->get('course_id');						
			
			$model->setState('course_id', $courseId);			
			
			$body = $model->addHistoryToBody($message->message, $message->date, true);		
			
			$view = $this->getView('message', 'html');
			$view->courseId = $courseId;
			$view->form	= $model->getForm('message');			
			$view->form->bind(array('subject' => 'RE: '.$message->subject, 'message' => $body, 'recipients' => $message->sender_id));
			$view->setModel($model, true);			
			$view->compose();
		}
		
		return true;
	}

	public function forward()
	{	
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		
		if ($model = $this->getModel('message'))
		{	
			$courseId = $this->config->get('course_id');	
			
			$model->setState('course_id', $courseId);
			
			$message = $model->getMessage($this->input->getInt('id'));		

			$body = $model->addHistoryToBody($message->message, $message->date);			
						
			$view = $this->getView('message', 'html');			
			$view->courseId = $courseId;
			$view->form	= $model->getForm('message');
			$view->form->bind(array('subject' => 'FW: '.$message->subject, 'message' => $body, 'parent_id' => $message->id));
			$view->setModel($model, true);
			$view->compose();
		}
		
		return true;
	}
	
	public function loadFile()
	{		
		if(!$this->user->get('id')) {
			$this->setRedirect(sefRelToAbs('index.php?option=com_joomla_lms'));
			return JError::raiseError(401, JText::_('You are not authorized to view this resource'));
		}
		
		if ($model = $this->getModel('message')) {
			$model->loadFile($this->input->get('message_id'), $this->user->get('id'));
		}
		
		//JLMSRedirect( sefRelToAbs("index.php?option=$option&amp;Itemid=$Itemid&amp;id=$course_id&amp;task=mailbox") );	
	}	
}