<?php
namespace LMS\Tools\Subscriptions\Model;

use LMS\Tools\Subscriptions\Repositories AS Rep;
use LMS\Libraries;
use LMS\Libraries\Base;

defined('_JEXEC') or die;

class Subscription extends Base\Model
{
	protected $name = 'Subscription';
	
	protected $modelDir = __DIR__;

	public function __construct($options = array())
	{		
		$this->repository = new Rep\Subscription();		
		$this->repositorySubscriptionsCourses = new Rep\SubscriptionsCourses();
	
		parent::__construct($options);
	}
	
	public function save($data)
	{			
		$data['published'] = 1;
		
		$this->repository->save($data);
		
		$id = $this->repository->getId();
		
		$this->repositorySubscriptionsCourses->save(array('sub_id' => $id, 'course_id' => $this->getState('course_id')));
	}
	
	public function delete($id)
	{			
		$this->repository->delete(array('id' => $id));
		
		$this->repositorySubscriptionsCourses->delete(array('sub_id' => $id));
	}
	
	protected function loadFormData()
	{		
		$app = Libraries\ServiceLocator::get('application');
		
		$data = $app->getUserState('com_joomla_lms.subscription.data', array());			
		
		return $data;
	}
}