<?php
 
namespace LMS\Tools\Users\Model;
 
defined('_JEXEC') or die;

use LMS\Libraries;
use LMS\Libraries\Repository;
use LMS\Libraries\User;
use LMS\Libraries\Base;
use LMS\Libraries\ServiceLocator;

class Groups extends Base\Model
{	
	var $context = 'groups';	
	
	var $modelDir = __DIR__;
		
	public function __construct()
	{		
		$this->repository = Libraries\ServiceLocator::get('group_rep');
		
		parent::__construct();
		
		$this->setState('fields','group.name, group.id');
	}		
	
	protected function loadFormData() 
	{
		$data = new \JObject();				
		$data->set('search', $this->getState('filter.search'));		

		return $data;
	}	
	
	public function getGroupsNames($ids) 
	{
		$options = array(
				'fields'=>'DISTINCT group.name',
				'resultType'=>'column'
		);
				
		if(empty($ids) && empty($excludedIds)) {
			$options['group_id'] = array();
		} else {
			if(!empty($ids)) {
				$options['group_id'] = $ids;
			}
			
			if(!empty($excludedIds)) {	
				$options['exluded_group_id'] = $excludedIds;
			}
		}		
		
		$rep	= ServiceLocator::get('group_rep');
	
		$groupsNames = $rep->getByFilter($options);

		if(in_array('0', $ids)) {
			$groupsNames[] = \JText::_('_JLMS_USER_NO_GROUP_NAME');
		}
		
		return $groupsNames;
	}
	
	public function getItems() 
	{		
		$items = parent::getItems();
		
		if($this->getState('list.start') == 0) {
			$itemNoGroup = new \stdClass();
			$itemNoGroup->id = 0;
			$itemNoGroup->name = \JText::_('_JLMS_USER_NO_GROUP_NAME');
			
			array_unshift($items, $itemNoGroup);
		}	
		
		return $items;
	}
	
	public function getTotal() 
	{	
		$total = parent::getTotal();		
		
		$total++;		
		
		return $total;
	}	
}